/* fta6d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int fta6d_c(doublereal *array, integer *ndim, integer *mesh,
        integer *ireg)
{
    /* Initialized data */

    static doublereal sys003 = 6.283185307179586;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4, i__5, i__6;
    doublereal d__1;

    /* Builtin functions */
    double sin(doublereal);

    /* Local variables */
    static integer idim, i2ip1, i3ip1, ibit, nrem;
    static real temp;
    static integer ntot, i2rev, i3rev, n;
    static doublereal theta, tempi, tempr;
    static integer nprev, i2, i1, i3, k1, k2;
    static doublereal wtemp, wi, wr;
    static integer ip1, ip2, ip3;
    static doublereal wpi, wpr;
    static integer ifp1, ifp2;

    /* Parameter adjustments */
    --array;
    --mesh;

    /* Function Body */
    ntot = 1;
    i__1 = *ndim;
    for (idim = 1; idim <= i__1; ++idim) {
        ntot *= mesh[idim];
/* L10: */
    }
    nprev = 1;
    i__1 = *ndim;
    for (idim = 1; idim <= i__1; ++idim) {
        n = mesh[idim];
        nrem = ntot / (n * nprev);
        ip1 = nprev << 1;
        ip2 = ip1 * n;
        ip3 = ip2 * nrem;
        i2rev = 1;
        i__2 = ip2;
        i__3 = ip1;
        for (i2 = 1; i__3 < 0 ? i2 >= i__2 : i2 <= i__2; i2 += i__3) {
            if (i2 >= i2rev) {
                goto L40;
            }
            i2ip1 = i2 + ip1 - 2;
            i__4 = i2ip1;
            for (i1 = i2; i1 <= i__4; i1 += 2) {
                i__5 = ip3;
                i__6 = ip2;
                for (i3 = i1; i__6 < 0 ? i3 >= i__5 : i3 <= i__5; i3 += i__6) 
                        {
                    i3rev = i2rev + i3 - i2;
                    tempr = array[i3];
                    tempi = array[i3 + 1];
                    array[i3] = array[i3rev];
                    array[i3 + 1] = array[i3rev + 1];
                    array[i3rev] = tempr;
                    array[i3rev + 1] = tempi;
/* L20: */
                }
/* L30: */
            }
L40:
            ibit = ip2 / 2;
L50:
            if (ibit >= ip1 && i2rev > ibit) {
                goto L60;
            }
            goto L70;
L60:
            i2rev -= ibit;
            ibit /= 2;
            goto L50;
L70:
            i2rev += ibit;
/* L80: */
        }
        ifp1 = ip1;
L90:
        if (ifp1 >= ip2) {
            goto L130;
        }
        ifp2 = ifp1 << 1;
        theta = *ireg * sys003 / (ifp2 / ip1);
/* Computing 2nd power */
        d__1 = sin(theta * .5);
        wpr = d__1 * d__1 * -2.;
        wpi = sin(theta);
        wr = 1.;
        wi = 0.;
        i__3 = ifp1;
        i__2 = ip1;
        for (i3 = 1; i__2 < 0 ? i3 >= i__3 : i3 <= i__3; i3 += i__2) {
            i3ip1 = i3 + ip1 - 2;
            i__4 = i3ip1;
            for (i1 = i3; i1 <= i__4; i1 += 2) {
                i__6 = ip3;
                i__5 = ifp2;
                for (i2 = i1; i__5 < 0 ? i2 >= i__6 : i2 <= i__6; i2 += i__5) 
                        {
                    k1 = i2;
                    k2 = k1 + ifp1;
                    tempr = wr * array[k2] - wi * array[k2 + 1];
                    tempi = wr * array[k2 + 1] + wi * array[k2];
                    array[k2] = array[k1] - tempr;
                    array[k2 + 1] = array[k1 + 1] - tempi;
                    array[k1] += tempr;
                    array[k1 + 1] += tempi;
/* L100: */
                }
/* L110: */
            }
            wtemp = wr;
            wr = wr * wpr - wi * wpi + wr;
            wi = wi * wpr + wtemp * wpi + wi;
/* L120: */
        }
        ifp1 = ifp2;
        goto L90;
L130:
        nprev = n * nprev;
/* L140: */
    }
    if (*ireg == 1) {
        goto L160;
    }
    n = ntot << 1;
    temp = 1. / (doublereal) ntot;
    i__1 = n;
    for (i1 = 1; i1 <= i__1; ++i1) {
        array[i1] = temp * array[i1];
/* L150: */
    }
L160:
    return 0;
} /* fta6d_c */
